@import "../../../../assets/utils";

.container {
  display: flex;
  align-items: center;
  cursor: pointer;
  user-select: none;
}

.isDisabled {
  opacity: .6;
  pointer-events: mouseover;
  cursor: not-allowed;
}

.isReadonly {
  opacity: .8;
  cursor: default !important;

  .icon {
    border-style: dotted !important;

  }
}

.icon {
  height: 16px;
  width: 16px;

  border: 1px solid $color-primary-lighter;
  transition: background .1s ease-in-out, border .1s ease-in-out;

  &.isChecked {
    border: 2px solid $color-primary-lighter;
    &.checkboxType {
      background: $color-primary-lighter;
    }
    &.radioType {
      &:after {
        height: 8px;
        width: 8px;
      }
    }
  }
}

.checkboxType {
  border-radius: 4px;

  display: flex;
  align-items: center;
  justify-content: center;

  svg {
    transition: fill .1s ease-in-out;
  }

  &:not(.isChecked) {
    svg {
      fill: none;
    }
  }

  &.isChecked {
    svg {
      fill: $color-secondary;
    }
  }
}

.radioType {
  border-radius: 100%;
  position: relative;

  &:after {
    content: '';
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translateY(-50%) translateX(-50%);
    background: $color-primary-lighter;
    display: block;
    border-radius: 100%;
    height: 0;
    width: 0;

    transition: height .1s, width .1s;
  }
}

.label {
  margin-left: 12px;
  color: #333333;
  cursor: inherit;
  transition: color .1s ease-in-out;
}

.container {
  &:not(.isChecked) {
    &:not(.isDisabled):not(.isReadonly) {
      &:hover {
        .icon {
          border: 2px solid $color-primary-lighter;
        }
      }
    }

    &.isValid {
      .icon {
        border: 1px solid $color-success;
      }

      &:not(.isDisabled):not(.isReadonly) {
        &:hover {
          .icon {
            border: 2px solid $color-success;
          }
        }
      }
    }

    &.isInvalid {
      .icon {
        border: 1px solid $color-warning;
      }

      &:not(.isDisabled):not(.isReadonly) {
        &:hover {
          .icon {
            border: 2px solid $color-warning;
          }
        }
      }
    }
  }

  &.isChecked {
    &:not(.isDisabled):not(.isReadonly) {
      &:hover {
        .icon {
          border: 2px solid lighten($color-primary-lighter, 5%);

          &.checkboxType {
            background: lighten($color-primary-lighter, 10%);
          }
          &.radioType {
            &:after {
              background: lighten($color-primary-lighter, 10%);
            }
          }
        }
      }
    }

    &.isValid {
      .icon {
        background: $color-success;
        border: 2px solid $color-success;
        &.checkboxType {
          background: $color-success;
        }
        &.radioType {
          &:after {
            background: $color-success;
          }
        }
      }

      &:not(.isDisabled):not(.isReadonly) {
        &:hover {
          .icon {
            border: 2px solid lighten($color-success, 5%);
            &.checkboxType {
              background: lighten($color-success, 10%);
            }
            &.radioType {
              &:after {
                background: lighten($color-success, 10%);
              }
            }
          }
        }
      }
    }

    &.isInvalid {
      .icon {
        border: 2px solid $color-warning;
        &.checkboxType {
          background: $color-warning;
        }
        &.radioType {
          &:after {
            background: $color-warning;
          }
        }
      }

      &:not(.isDisabled):not(.isReadonly) {
        &:hover {
          .icon {
            border: 2px solid lighten($color-warning, 5%);
            &.checkboxType {
              background: lighten($color-warning, 10%);
            }
            &.radioType {
              &:after {
                background: lighten($color-warning, 10%);
              }
            }
          }
        }
      }
    }
  }

  &.isValid {
    .label {
      color: $color-success;
    }
  }

  &.isInvalid {
    .label {
      color: $color-warning;
    }
  }
}
